/* This file is Copyright 2002 Level Control Systems.  See the included LICENSE.txt file for details. */

#ifndef MuscleGlobalMemoryAllocator_h
#define MuscleGlobalMemoryAllocator_h

#include "util/MemoryAllocator.h"

namespace muscle {

/** Set the MemoryAllocator object that is to be called by the C++ global new and delete operators 
  * @param maRef Reference to The new MemoryAllocator object to use.  May be a NULL reference
  *              if you just want to remove any current MemoryAllocator.
  */
void SetCPlusPlusGlobalMemoryAllocator(MemoryAllocatorRef maRef);

/** Returns a reference to the current MemoryAllocator object that is being used by the 
  * C++ global new and delete operators.  Will return a NULL reference if no MemoryAllocator
  * is in use.
  */
MemoryAllocatorRef GetCPlusPlusGlobalMemoryAllocator();

};  // end namespace muscle

#endif
